// Sedgewick program 3.12
// doppelt verkettete Liste benutzen
// elementare Listenoperationen kommen aus CircularList

class JosephusY { 
    public static void main(String[] args) {
	int N = 0; 
	int M = 0;
	try {
		N = Integer.parseInt(args[0]);
        	M = Integer.parseInt(args[1]);
	} catch (Exception e) {
		Out.println("Usage: java JosephusY #Nodes #Deleted");
		System.exit(1);
	}
        CircularList L = new CircularList();
        CircularList.Node x = null;
        for (int i = 1; i <= N; i++)
          x = L.insert(x, i); 
        while (x != L.next(x))
          {
            for (int i = 1; i < M; i++) 
              x = L.next(x);
            L.remove(x);
          }
        Out.println("Survivor is " + L.val(x));
      }
  }
